﻿' This is the interface class for GP3UI
' Use it to talk to GP3EZ
Public Class gp3ui
    Private skt As System.Net.Sockets.TcpClient   ' socket
    Private netio As System.Net.Sockets.NetworkStream  ' socket stream
    Private enc As System.Text.ASCIIEncoding   ' convert strings to bytes
    Private buf(128) As Byte   ' generic buffer
    Private main As Form   ' owner
    Public gp3ezversion As Char  ' the protocol version
    ' This is a function that lets you set the data into your form fields
    Public Delegate Sub SetTextCallback(ByVal c As Control, ByVal vtext As String, ByVal xtra As String)

    ' find out if we are connected
    Public ReadOnly Property IsConnected() As Boolean
        Get
            IsConnected = (Not (skt Is Nothing))
        End Get
    End Property

    ' Start an async read on the socket
    Private Sub StartRead()
        Dim cb As AsyncCallback
        Dim i As Integer
        cb = New AsyncCallback(AddressOf callback)
        For i = 0 To buf.Length - 1
            buf(i) = 0
        Next
        netio.BeginRead(buf, 0, buf.Length, cb, vbNull)

    End Sub

    ' disconnect
    Public Sub disconnect()
        Try
            If skt IsNot Nothing Then
                sendRawString("!bye")
                netio.Flush()
                netio.Close()
                skt.Close()
                skt = Nothing
            End If
        Catch ex As Exception
            ' nothing to do
        End Try

    End Sub
    ' Connect
    Public Sub connect(ByVal host As String, ByVal port As Integer)
        If skt IsNot Nothing Then
            disconnect()
        End If
        Try
            skt = New System.Net.Sockets.TcpClient(host, port)
            netio = skt.GetStream
            sendRawString(":0") ' send version string
            netio.Read(buf, 0, buf.Length)  ' read version string

        Catch ex As Exception
            MessageBox.Show("Can't Connect: " + ex.Message)
            Exit Sub
        End Try
        If Microsoft.VisualBasic.ChrW(buf(0)).ToString <> ":" Then
            gp3ezversion = "!"
        Else
            gp3ezversion = Microsoft.VisualBasic.ChrW(buf(1))
        End If
        StartRead()
    End Sub

    ' create a new object and connect
    Public Sub New(ByVal f As Form, ByVal host As String, ByVal port As Integer)
        enc = New System.Text.ASCIIEncoding
        main = f
        connect(host, port)
    End Sub

    ' You can vector your set text implementation here
    ' it finds Checked or Text field and plugs values in
    Public Sub SetText(ByVal c As Control, ByVal vtext As String, ByVal xtra As String)
        Dim minfo() As System.Reflection.MemberInfo
        c.Show()
        minfo = c.GetType.FindMembers(System.Reflection.MemberTypes.Property, Reflection.BindingFlags.Public + Reflection.BindingFlags.Instance, System.Type.FilterName, "Checked")
        If minfo.Length <> 0 Then
            Dim n As Integer
            Dim v As Integer
            Dim o As Object
            o = c
            Integer.TryParse(xtra, n)
            Integer.TryParse(vtext, v)
            If n >= 8 Then
                n = n - 8
                v = Not v
            End If
            If (v And 2 ^ n) = 0 Then
                o.Checked = False
            Else
                o.Checked = True
            End If
            Exit Sub
        End If
        ' default set text
        If xtra = "" Then
            c.Text = vtext
        Else
            Dim v As Single
            v = Single.Parse(vtext)
            c.Text = Format(v, xtra)
        End If
    End Sub
    ' This SetText routine vectors through the async read thread
    Public Sub SetText(ByVal c As Control, ByVal vtext As String, ByVal xtra As String, ByVal cb As SetTextCallback)

        If c.InvokeRequired Then
            main.Invoke(cb, New Object() {c, vtext, xtra})
        Else
            SetText(c, vtext, xtra)
        End If
    End Sub
    ' When the async read completes we come here
    ' We scan the form looking for a TAG that matches the incoming GP3EZ tag
    ' then we call the SetText chains
    Private Sub callback(ByVal r As IAsyncResult)
        Dim s As String
        Dim tag As String
        Dim c(256) As Char
        Dim n As Integer
        Dim o As Object
        If skt Is Nothing Then Exit Sub
        Try
            If netio.EndRead(r) <= 0 Then
                netio.Close()
                skt.Close()
                skt = Nothing
                Exit Sub
            End If
        Catch ex As Exception
            ' nothing to do here
        End Try
        o = main
        enc.GetChars(buf, 0, buf.Length, c, 0)
        s = New String(c, 0, c.Length)
        n = s.IndexOf(":")
        If n <= 0 Then Exit Sub
        tag = s.Substring(0, n)
        s = s.Substring(n + 1)
        ' need to search for right control on main (VB won't do late binding except through Object?)
        For Each ctl As Control In main.Controls
            Dim ctag As String
            Dim xtra As String
            If ctl.Tag Is Nothing Then Continue For
            n = ctl.Tag.ToString.IndexOf(":")
            If n <= 0 Then
                ctag = ctl.Tag
                xtra = ""
            Else
                ctag = ctl.Tag.ToString.Substring(0, n)
                xtra = ctl.Tag.ToString.Substring(n + 1)
            End If
            If ctag = tag Then
                o.SetControlText(ctl, s, xtra)
            End If
        Next
        'Start another read
        StartRead()
    End Sub
    ' Send a string trigger command to GP3EZ
    Public Sub sendString(ByVal tag As String, ByVal cmd As String)
        sendRawString(tag + ":" + cmd)
    End Sub
    ' Send a raw string to GP3EZ
    Public Sub sendRawString(ByVal s As String)
        Dim ary As Byte()
        If s Is Nothing Then Exit Sub
        ary = enc.GetBytes(s)
        netio.Write(ary, 0, ary.Length)
    End Sub
    ' GP3EZ control subroutines
    Public Sub startscript()
        sendRawString("!start")
    End Sub
    Public Sub stopscript()
        sendRawString("!stop")
    End Sub
    Public Sub quitGP3EZ()
        sendRawString("!quit")
    End Sub
    Public Sub hideGP3EZ()
        sendRawString("!hide")
    End Sub
    Public Sub showGP3EZ()
        sendRawString("!show")
    End Sub
    Public Sub resetTriggers()
        sendRawString("!treset")
    End Sub
End Class
